import { trigger, transition, style, animate, state, keyframes } from '@angular/animations';
var defaultT = '.3s ease-out';
export function carousel(t, style1, style2, style3) {
    if (t === void 0) { t = '.3s ease'; }
    if (style1 === void 0) { style1 = { transform: 'translateX(-100%)' }; }
    if (style2 === void 0) { style2 = { transform: 'translateX(100%)' }; }
    if (style3 === void 0) { style3 = { position: 'absolute', width: '*', top: 0, left: 0 }; }
    return trigger('Carousel', [
        transition('left=>void', [style(style3), animate(t, style(style1))]),
        transition('void=>left', [style(style1), animate(t)]),
        transition('right=>void', [style(style3), animate(t, style(style2))]),
        transition('void=>right', [style(style2), animate(t)])
    ]);
}
export function menu(t, style1) {
    if (t === void 0) { t = '.2s ease-out'; }
    if (style1 === void 0) { style1 = { transform: 'scale(.1,.1)', opacity: 0 }; }
    return trigger('Menu', [
        transition('*=>show', [style(style1), animate(t)]),
        transition('show=>hid', [animate(t, style({ opacity: 0 }))])
    ]);
}
export function horizonRight(t, style1) {
    if (t === void 0) { t = '.1s ease'; }
    if (style1 === void 0) { style1 = { transform: 'translateX(100%)', display: 'none' }; }
    return trigger('HorizonRight', [
        state('hid', style(style1)),
        transition('*=>*', [animate(t)])
    ]);
}
export function verticalUp(t, style1) {
    if (t === void 0) { t = defaultT; }
    if (style1 === void 0) { style1 = { transform: 'translateY(100%)' }; }
    return trigger('VerticalUp', [
        transition('void=>*', [style(style1), animate(t)]),
        transition('*=>void', [animate(t, style(style1))])
    ]);
}
export function collapse(t, style1) {
    if (t === void 0) { t = '.2s ease-out'; }
    if (style1 === void 0) { style1 = { height: 0 }; }
    return trigger('Collapse', [
        transition('show=>void', [animate(t, style(style1))]),
        transition('void=>show', [style(style1), animate(t)])
    ]);
}
export function fade(t, style1) {
    if (t === void 0) { t = defaultT; }
    if (style1 === void 0) { style1 = { opacity: 0 }; }
    return trigger('Fade', [
        transition('*=>void', [animate(t, style(style1))]),
        transition('void=>*', [style(style1), animate(t)])
    ]);
}
export function sideRight(t, style1) {
    if (t === void 0) { t = defaultT; }
    if (style1 === void 0) { style1 = { transform: 'translateX(-100%)' }; }
    return trigger('SideRight', [
        transition('*=>void', [animate(t, style(style1))]),
        transition('void=>*', [style(style1), animate(t)])
    ]);
}
export function modal(t, t2) {
    if (t === void 0) { t = defaultT; }
    if (t2 === void 0) { t2 = '.2s ease'; }
    return trigger('Modal', [
        transition('*=>void', [animate(t2, style({ opacity: 0, top: '-10%' }))]),
        transition('void=>*', [style({ top: '0%', opacity: .5 }), animate(t)])
    ]);
}
export function pop(t1, t2) {
    if (t1 === void 0) { t1 = defaultT; }
    if (t2 === void 0) { t2 = '.2s ease'; }
    return trigger('Pop', [
        transition('void=>*', [animate(t1, keyframes([
                style({ opacity: 0, transform: 'scale(.7,.7)', offset: 0 }),
                style({ opacity: 1, transform: 'scale(1.2,1.2)', offset: 0.8 }),
                style({ transform: 'scale(1,1)', offset: 1 })
            ]))]),
        transition('*=>void', [animate(t2, style({ opacity: 0, transform: 'translateY(-40%)' }))])
    ]);
}
//# sourceMappingURL=base.js.map