import { Directive, ElementRef } from '@angular/core';
import { CollapseItemComponent } from './collapseItem.component';
import { CollapseComponent } from './collapse.component';
var CollaspeBtnDirective = (function () {
    function CollaspeBtnDirective(_el, _parent, _ancestor) {
        var _this = this;
        this._el = _el;
        this._parent = _parent;
        this._ancestor = _ancestor;
        this.addType(this._ancestor._type);
        this._ancestor.typeSub.subscribe(function (type) { return _this.addType(type); });
    }
    CollaspeBtnDirective.prototype.addType = function (type) {
        if (type === this.nowType)
            return;
        var node = this._el.nativeElement;
        var reg = type !== null ? /(btn-\w?|_clp-btn-\w?)/g : /(btn-\w?|_clp-btn-\w?|collapse-btn\s?)/g;
        node.className = node.className.replace(reg, '');
        if (type !== null) {
            node.classList.add("btn-" + type, "_clp-btn-" + type, 'collapse-btn');
        }
        else {
            node.classList.add('collapse-null-btn');
        }
        this.nowType = type;
    };
    CollaspeBtnDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngz-collapse-btn]',
                    host: {
                        class: 'btn w-100',
                        '(click)': '_parent.toggle()',
                        '[class.active]': '_ancestor.preIndex===_parent.index'
                    }
                },] },
    ];
    /** @nocollapse */
    CollaspeBtnDirective.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: CollapseItemComponent, },
        { type: CollapseComponent, },
    ]; };
    return CollaspeBtnDirective;
}());
export { CollaspeBtnDirective };
//# sourceMappingURL=collapseBtn.directive.js.map