import { Component, Input, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { verticalUp } from '../../animate/base';
import { ToolService } from '../../tool/tool.service';
var FooterNoticeComponent = (function () {
    function FooterNoticeComponent(tool) {
        this.tool = tool;
        //timeout(ms);
        this.timeout = 2000;
        this.type = 'p';
        this.isStr = function (val) { return typeof val == 'string'; };
    }
    ;
    Object.defineProperty(FooterNoticeComponent.prototype, "_type", {
        set: function (val) {
            if (val)
                this.type = val;
        },
        enumerable: true,
        configurable: true
    });
    FooterNoticeComponent.prototype.ngOnInit = function () {
        if (this.timeout)
            this.timer = new this.tool.timerTool(this.timeout);
    };
    FooterNoticeComponent.prototype.registerOnTouched = function () { };
    FooterNoticeComponent.prototype.registerOnChange = function (fn) {
        this.changeFn = fn;
    };
    FooterNoticeComponent.prototype.writeValue = function (value) {
        var _this = this;
        if (!value)
            return;
        if (this.timer) {
            this.timer.finish();
            this.timer.next(function () { return _this.close(); });
        }
        this.value = value;
    };
    FooterNoticeComponent.prototype.close = function () {
        if (this.timer)
            this.timer.finish();
        this.changeFn(this.value = null);
    };
    FooterNoticeComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngz-footer-notice',
                    template: "\n        <div class=\"fix-bottom\">\n            <div *ngIf=\"value\" [@VerticalUp] class=\"alert-{{type}}\" style=\"min-width:15em;\">\n                <span (click)=\"close()\" class=\"close\">&times;</span>\n                <a *ngIf='isStr(value)' [innerHTML]=\"value\"></a>\n                <a *ngIf=\"!isStr(value)\" [innerTp]=\"value\"></a>\n            </div>\n        </div>\n    ",
                    providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return FooterNoticeComponent; }), multi: true }
                    ],
                    animations: [verticalUp()]
                },] },
    ];
    /** @nocollapse */
    FooterNoticeComponent.ctorParameters = function () { return [
        { type: ToolService, },
    ]; };
    FooterNoticeComponent.propDecorators = {
        'timeout': [{ type: Input },],
        '_type': [{ type: Input, args: ['type',] },],
    };
    return FooterNoticeComponent;
}());
export { FooterNoticeComponent };
//# sourceMappingURL=footer-notice.component.js.map