import { Component, forwardRef, Input } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { ToolService } from '../../tool/tool.service';
import { pop } from '../../animate/base';
var MinModalComponnet = (function () {
    function MinModalComponnet(tool) {
        this.tool = tool;
        this.type = '';
    }
    MinModalComponnet.prototype.open = function () {
        var _this = this;
        if (this.isOpen)
            return;
        this.isOpen = true;
        setTimeout(function () { return _this.tool.listenOnce(document, 'click', _this.close.bind(_this)); });
    };
    MinModalComponnet.prototype.close = function () {
        if (!this.isOpen)
            return;
        this.isOpen = false;
        this.changeFn(null);
    };
    MinModalComponnet.prototype.registerOnTouched = function () { };
    MinModalComponnet.prototype.registerOnChange = function (fn) {
        this.changeFn = fn;
    };
    MinModalComponnet.prototype.writeValue = function (value) {
        if (!value)
            return;
        this.value = value;
        this.open();
    };
    MinModalComponnet.decorators = [
        { type: Component, args: [{
                    selector: 'ngz-min-modal',
                    template: "\n<div [@Pop] class=\"min-modal\" *ngIf=\"isOpen\">\n    <span (click)=\"close()\" class=\"color-{{type}} close abs-tr-0\" >&times;</span>\n    <div class=\"rel\">\n    </div>\n    <p class=\"color-{{type}}\">{{value}}\n    </p>\n</div>",
                    providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return MinModalComponnet; }), multi: true }
                    ],
                    host: {
                        'class': 'fix-center'
                    },
                    animations: [pop()]
                },] },
    ];
    /** @nocollapse */
    MinModalComponnet.ctorParameters = function () { return [
        { type: ToolService, },
    ]; };
    MinModalComponnet.propDecorators = {
        'type': [{ type: Input },],
    };
    return MinModalComponnet;
}());
export { MinModalComponnet };
//# sourceMappingURL=min-modal.component.js.map