import { Input, ViewChild, EventEmitter, ElementRef, ContentChildren, Component, Output, Directive, ComponentFactoryResolver, TemplateRef, ChangeDetectionStrategy, ChangeDetectorRef } from '@angular/core';
import { carousel, fade } from '../../animate/base';
import { ToolService } from '../../tool/tool.service';
/*
how to use:
  <ngz-tab>

    <ngz-tabContent>content1</ngz-tabContent>
    <button ngz-tabBtn>btn1</button>

  </ngz-tab>
 */
//ztwTabContent:
var ngzTabContent = (function () {
    function ngzTabContent(tp) {
        this.tp = tp;
    }
    ngzTabContent.decorators = [
        { type: Directive, args: [{
                    selector: '[ngz-tabContent]'
                },] },
    ];
    /** @nocollapse */
    ngzTabContent.ctorParameters = function () { return [
        { type: TemplateRef, },
    ]; };
    return ngzTabContent;
}());
export { ngzTabContent };
//ngz-tabBtn:
var ngzTabBtn = (function () {
    //active:boolean;
    function ngzTabBtn(_el) {
        this._el = _el;
        this.node = _el.nativeElement;
    }
    ngzTabBtn.prototype.click = function () { };
    ngzTabBtn.decorators = [
        { type: Directive, args: [{
                    selector: '[ngz-tabBtn]',
                    host: {
                        '(click)': 'click()',
                        'class': 'tab-btn'
                    }
                },] },
    ];
    /** @nocollapse */
    ngzTabBtn.ctorParameters = function () { return [
        { type: ElementRef, },
    ]; };
    return ngzTabBtn;
}());
export { ngzTabBtn };
//ngz-tab:
var ngzTabComponent = (function () {
    function ngzTabComponent(_cfr, tool, _cd) {
        this._cfr = _cfr;
        this.tool = tool;
        this._cd = _cd;
        this.select = new EventEmitter();
        this.type = 'l';
        this.selectItem = 0;
    }
    Object.defineProperty(ngzTabComponent.prototype, "default", {
        set: function (val) {
            if (val !== undefined)
                this.selectItem = val;
        },
        enumerable: true,
        configurable: true
    });
    ngzTabComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.initBtn();
        this.initContent();
        this.contents.changes.subscribe(function () { return _this.initContent(); });
        this.btns.changes.subscribe(function () { return _this.initBtn(); });
    };
    ngzTabComponent.prototype.initBar = function () {
        this.stripBar = document.createElement('div');
        this.stripBar.className = 'strip-bar';
        this.btnControls[0].node.appendChild(this.stripBar);
        if (this.selectItem !== 0)
            this.setBar(this.selectItem);
    };
    ngzTabComponent.prototype.setBar = function (index) {
        this.stripBar.style.transform = "translateX(" + index * 100 + "%)";
    };
    ngzTabComponent.prototype.open = function (index) {
        var _this = this;
        if (index == this.selectItem)
            return;
        var now = this.contentControls[index], pre = this.contentControls[this.selectItem];
        if (index > this.selectItem) {
            now.state = 'right';
            pre.state = 'left';
        }
        else {
            now.state = 'left';
            pre.state = 'right';
        }
        //this.btnControls[index].active=true;
        //this.btnControls[this.selectItem].active=false;
        !this.disabledDefault && this.setBar(index);
        this._cd.markForCheck();
        setTimeout(function () {
            _this.selectItem = index;
            _this.select.emit(index);
            _this._cd.markForCheck();
        });
    };
    ngzTabComponent.prototype.initContent = function () {
        this.contentControls = this.contents._results;
        this.len = this.contentControls.length;
    };
    ngzTabComponent.prototype.initBtn = function () {
        var _this = this;
        this.btnControls = this.btns._results;
        !this.disabledDefault && this.initBar();
        //this.btnControls[this.selectItem].active=true;
        this.btnControls.forEach(function (control, index) { return _this.btnControls[index].click = function () { return _this.open(index); }; });
    };
    ngzTabComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngz-tab',
                    template: "      \n    <div [ngClass]=\"!disabledDefault?'tab-group-'+type+' tab-group':''\">\n      <div [class.bottomLine]=\"!noNavLine\">\n        <div class=\"tab-btn-group rel\" [ngClass]=\"appendNav\">\n            <ng-content select=\"[ngz-tabBtn]\"></ng-content>\n        </div>\n      </div>\n      <div class=\"rel tab-container\" [ngClass]=\"appendBlock\">\n          <ng-template [ngForOf]=\"contentControls\" ngFor  let-i let-index=\"index\">\n              <div [@Carousel]=\"i.state\" *ngIf=\"index==selectItem;\">\n                    <a [innerTp]=\"i.tp\"></a>\n              </div>\n          </ng-template>\n       <div>\n    </div>\n      ",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    animations: [carousel(), fade()]
                },] },
    ];
    /** @nocollapse */
    ngzTabComponent.ctorParameters = function () { return [
        { type: ComponentFactoryResolver, },
        { type: ToolService, },
        { type: ChangeDetectorRef, },
    ]; };
    ngzTabComponent.propDecorators = {
        'disabledDefault': [{ type: Input },],
        'noNavLine': [{ type: Input },],
        'appendBlock': [{ type: Input },],
        'appendNav': [{ type: Input },],
        'select': [{ type: Output, args: ['select',] },],
        'bar': [{ type: ViewChild, args: ['bar',] },],
        'default': [{ type: Input, args: ['defaultIndex',] },],
        'type': [{ type: Input },],
        'contents': [{ type: ContentChildren, args: [ngzTabContent,] },],
        'btns': [{ type: ContentChildren, args: [ngzTabBtn,] },],
    };
    return ngzTabComponent;
}());
export { ngzTabComponent };
//# sourceMappingURL=ztw-tab.component.js.map