import { Component, Input } from '@angular/core';
import { fade, sideRight } from '../../animate/base';
var SideNavComponent = (function () {
    function SideNavComponent() {
        this.paddingTop = 10;
    }
    SideNavComponent.prototype.open = function () {
        if (this.show || this.prevent)
            return;
        this.prevent = true;
        this.show = true;
    };
    SideNavComponent.prototype.close = function () {
        if (!this.show || this.prevent)
            return;
        this.prevent = true;
        this.show = false;
    };
    SideNavComponent.prototype.toggle = function () {
        this.show ? this.close() : this.open();
    };
    SideNavComponent.prototype.ngOnInit = function () {
    };
    SideNavComponent.prototype.sideDown = function () {
        this.prevent = false;
    };
    SideNavComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngz-nav-side',
                    template: "\n<div [@SideRight] *ngIf=\"show\" class=\"nav-side-c\" [style.width.px]=\"width\" (@SideRight.done)=\"sideDown()\">\n    <div (click)=\"close()\" class=\"rel\" [style.height.px]=\"paddingTop\">\n        <span class=\"close\" >&times;</span>\n    </div>\n    <div >\n        <ng-content></ng-content>\n    </div>\n</div>\n<div class=\"fix-bg\" [@Fade] *ngIf=\"show\" (click)=\"close()\">\n</div>\n  ",
                    animations: [sideRight(), fade()]
                },] },
    ];
    /** @nocollapse */
    SideNavComponent.ctorParameters = function () { return []; };
    SideNavComponent.propDecorators = {
        'paddingTop': [{ type: Input },],
        'width': [{ type: Input },],
        'tp': [{ type: Input },],
    };
    return SideNavComponent;
}());
export { SideNavComponent };
//# sourceMappingURL=side-nav.component.js.map