import { Directive, Output, EventEmitter, Input } from '@angular/core';
var ClickCopyDirective = (function () {
    function ClickCopyDirective() {
        this.copyComplete = new EventEmitter();
    }
    ClickCopyDirective.prototype.copy = function () {
        var body = document.body;
        var hid = this.getHidNode();
        body.appendChild(hid);
        var r = document.createRange();
        r.selectNode(hid);
        var w = window.getSelection();
        w.removeAllRanges();
        w.addRange(r);
        document.execCommand('copy');
        this.copyComplete.emit();
        body.removeChild(hid);
    };
    ClickCopyDirective.prototype.getHidNode = function () {
        var hid = document.createElement('p');
        hid.className = 'hidNode';
        hid.innerText = this.copyData;
        return hid;
    };
    ClickCopyDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngz-clickCopy]',
                    host: {
                        '(click)': 'copy()'
                    }
                },] },
    ];
    /** @nocollapse */
    ClickCopyDirective.ctorParameters = function () { return []; };
    ClickCopyDirective.propDecorators = {
        'copyData': [{ type: Input, args: ['ngz-clickCopy',] },],
        'copyComplete': [{ type: Output },],
    };
    return ClickCopyDirective;
}());
export { ClickCopyDirective };
//# sourceMappingURL=click-copy.directive.js.map