import { Directive, Input, ElementRef } from '@angular/core';
import { hHtml } from './lib/html';
import { hJs } from './lib/js';
var Highlight = (function () {
    function Highlight(_el) {
        this._el = _el;
        this.filterTag = function (val) { return val.replace(/</g, '&lt;').replace(/>/g, '&gt;'); };
        this.language = 'html'; //default 'html', options: 'js;
        this.stripe = false;
    }
    Object.defineProperty(Highlight.prototype, "highlight", {
        set: function (val) {
            if (!val)
                return;
            val = this.filterTag(val);
            var listVal = val.split(/\n/);
            var tableClass = 'z-hLight-table';
            if (this.stripe)
                tableClass += ' stripe';
            var str = "<table class=\"" + tableClass + "\">";
            listVal.forEach(function (v, index) {
                str += "<tr><td>" + index + "</td><td>" + v + "</td></tr>";
            });
            str += '</table>';
            switch (this.language) {
                case 'html':
                    str = hHtml(str);
                    break;
                case 'js':
                    str = hJs(str);
            }
            this._el.nativeElement.innerHTML = str;
        },
        enumerable: true,
        configurable: true
    });
    Highlight.decorators = [
        { type: Directive, args: [{
                    selector: '[highlight]',
                    host: {
                        'class': 'auto'
                    }
                },] },
    ];
    /** @nocollapse */
    Highlight.ctorParameters = function () { return [
        { type: ElementRef, },
    ]; };
    Highlight.propDecorators = {
        'language': [{ type: Input },],
        'stripe': [{ type: Input },],
        'highlight': [{ type: Input },],
    };
    return Highlight;
}());
export { Highlight };
//# sourceMappingURL=highlight.directive.js.map