var addStyle = function (node, style) {
    for (var i in style) {
        node.style[i] = style[i];
    }
};
var timerTool = (function () {
    function timerTool(timer) {
        this.timer = timer;
    }
    timerTool.prototype.next = function (fn) {
        var _this = this;
        this.setT = setTimeout(function () { _this.setT = null; fn(); }, this.timer);
    };
    timerTool.prototype.finish = function () {
        if (this.setT) {
            clearTimeout(this.setT);
            this.setT = null;
        }
    };
    return timerTool;
}());
export { timerTool };
var VoidAnimate = (function () {
    function VoidAnimate(opts) {
        var node = this.node = opts.node;
        this.timer = opts.timer || 300;
        this.start = opts.start;
        this.end = opts.end;
        this.tmTool = new timerTool(this.timer);
        this.endFn = function () {
            node && node.parentNode && node.parentNode.removeChild(node);
            opts.endCb && opts.endCb();
        };
        node.classList.add('animateNode');
    }
    Object.defineProperty(VoidAnimate.prototype, "state", {
        set: function (val) {
            var _this = this;
            this.tmTool.finish();
            if (val == 'start') {
                addStyle(this.node, this.start);
                setTimeout(function () { addStyle(_this.node, _this.end); }, 1);
            }
            else if (val == 'end') {
                addStyle(this.node, this.start);
                this.tmTool.next(this.endFn);
            }
            this._state = val;
        },
        enumerable: true,
        configurable: true
    });
    return VoidAnimate;
}());
export { VoidAnimate };
var NodeMethod = (function () {
    function NodeMethod() {
        this.listenOnce = function (node, event, cb) {
            var once = function () {
                cb();
                node.removeEventListener(event, once);
            };
            node.addEventListener(event, once);
        };
        this.timerTool = timerTool;
        this.addStyle = addStyle;
        this.voidAnimate = VoidAnimate;
    }
    return NodeMethod;
}());
export { NodeMethod };
//# sourceMappingURL=node.js.map