export function getPos(node) {
    var rect = node.getBoundingClientRect();
    return {
        left: Math.round(rect.left),
        top: Math.round(rect.top + window.pageYOffset + document.documentElement.clientTop),
        w: Math.round(rect.width),
        h: Math.round(rect.height)
    };
}
export function resizePos(pos, w) {
    var dis;
    if (pos.left) {
        dis = pos.left + w - window.innerWidth;
        if (dis > 0) {
            dis = dis + 20;
            pos.left = pos.left - dis;
        }
        pos.left = pos.left < 0 ? 0 : pos.left;
    }
    for (var i in pos) {
        pos[i] += 'px';
    }
    ;
    return dis;
}
export function tooltipPos(handleNode, tipNode, placement, isMid, space) {
    if (isMid === void 0) { isMid = true; }
    if (space === void 0) { space = 6; }
    var pos = getPos(handleNode), np = {}, body = document.querySelector('body'), w = tipNode.offsetWidth, h = tipNode.offsetHeight, newPos = function (k1, val1, k2, val2) { return (np[k1] = Math.round(val1)) && (np[k2] = Math.round(val2)); }, retreat = function (val) { return val + space; };
    var align = function () { };
    if (isMid) {
        align = function (base, len, len2) { return base + len / 2 - len2 / 2; };
    }
    else {
        align = function (base) { return base; };
    }
    switch (placement) {
        case 'top':
            newPos('bottom', retreat(body.offsetHeight - pos.top), 'left', align(pos.left, pos.w, w));
            break;
        case 'bottom':
            newPos('top', retreat(pos.top + pos.h + space), 'left', align(pos.left, pos.w, w));
            break;
        case 'left':
            newPos('top', align(pos.top, pos.h, h), 'right', retreat(body.offsetWidth - pos.left));
            break;
        case 'right':
            newPos('top', align(pos.top, pos.h, h), 'left', retreat(pos.left + pos.w));
    }
    var dis = resizePos(np, w);
    return { pos: np, dis: dis };
}
export function transitionOrigin(p) {
    return p == 'top' ? '0 100%' : (p == 'left' ? '100% 0' : '0 0');
}
//# sourceMappingURL=pos.js.map